function love.load()
  love.physics.setMeter(64) 
  world = love.physics.newWorld(0, 0, true)
  maxspeed = 100
  moving = false
  bullets = {}
  world:setCallbacks(beginContact, endContact, preSolve, postSolve)
  
      map = {
        {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}, 
		{1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1}, 
		{1,0,0,0,0,0,0,0,1,0,1,0,0,0,0,1,0,0,0,0,0,1,1,0,0,1,0,0,1,1,0,1}, 
		{1,0,0,0,0,0,0,0,1,1,0,1,0,0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,1,1,0,1}, 
		{1,0,1,0,1,0,0,1,1,0,0,1,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,1}, 
		{1,0,0,1,0,0,0,0,1,0,0,1,0,1,0,1,0,1,0,1,0,0,1,0,0,0,1,0,1,0,1,1}, 
		{1,0,0,1,1,0,1,1,0,0,1,1,0,0,0,0,0,0,0,0,1,0,0,1,0,1,0,0,0,1,0,1}, 
		{1,1,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1}, 
		{1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1}, 
		{1,0,1,0,0,1,0,0,1,0,1,0,1,1,1,1,1,0,0,0,0,0,1,0,0,0,1,0,1,0,0,1}, 
		{1,0,0,1,0,1,0,0,1,1,0,0,0,1,1,0,0,0,1,0,1,0,0,0,0,0,0,1,0,0,0,1}, 
		{1,1,1,1,1,0,0,0,1,1,1,0,1,1,0,1,0,1,0,0,1,0,0,0,0,1,0,0,0,1,0,1}, 
		{1,1,1,1,0,0,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1}, 
		{1,1,0,1,0,1,1,0,1,0,0,0,0,0,0,1,1,1,0,0,0,0,1,0,0,1,0,0,1,0,0,1}, 
		{1,0,0,0,0,0,0,1,0,1,1,1,0,1,0,0,1,0,1,0,0,0,0,0,1,0,1,0,1,0,0,1}, 
		{1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,0,1,1,0,0,1}, 
		{1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,0,0,0,1,1,0,1,0,0,1,0,0,1,1,1}, 
		{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}

	}
	mapscale = 30
  	windowx = 960
	windowy = 540
	centerx = windowx/2
	centery = windowy/2
	love.window.setMode(windowx, windowy, {resizable=false, vsync=true, centered=true})
	love.window.setTitle("PartyCöw - WIP")
  
  objects = {} -- table for all objects
 
  objects.ball = {}
  objects.ball.body = love.physics.newBody(world, windowx/2, windowy/2, "dynamic") --place the body in the center of the world and make it dynamic, so it can move around
  objects.ball.shape = love.physics.newCircleShape(10) --the ball's shape has a radius of 20
  objects.ball.fixture = love.physics.newFixture(objects.ball.body, objects.ball.shape, 1) -- Attach fixture to body and give it a density of 1.
  objects.ball.fixture:setRestitution(0) --let the ball bounce
  objects.ball.image = love.graphics.newImage("resources/player.png")

  --squares?
  derp = {}
--[[  for i2 = 1,1,1 do 
  for i = 1,50,1 do
  objects.block8 = {}
  objects.block8.body = love.physics.newBody(world, 10+i*10, 50+i2*10, "dynamic")
  objects.block8.shape = love.physics.newRectangleShape(0, 0, 10, 10)
  objects.block8.fixture = love.physics.newFixture(objects.block8.body, objects.block8.shape, 2)
  table.insert(derp,objects.block8)
  end
  end ]]
  
  ---WORLDGEN *YAY*------------------------------------------------------
  -----------------------------------------------------------------------
  -----------------------------------------------------------------------
  theworld = {}
  for wy = 1,#map,1 do 
  for wx = 1,#map[wy],1 do
  if map[wy][wx] == 1 then
  objects.blockw = {}
  objects.blockw.body = love.physics.newBody(world, (-mapscale/2)+wx*mapscale, (-mapscale/2)+wy*mapscale, "static")
  objects.blockw.shape = love.physics.newRectangleShape(0, 0, mapscale, mapscale)
  objects.blockw.fixture = love.physics.newFixture(objects.blockw.body, objects.blockw.shape, 2)
  table.insert(theworld,objects.blockw)
  end
  end
  end
  
  
  
  -----------------------------------------------------------------------
  -----------------------------------------------------------------------
  -----------------------------------------------------------------------

  --Borders..?
  objects.block3 = {}
  objects.block3.body = love.physics.newBody(world, -5, windowy/2, "static")
  objects.block3.shape = love.physics.newRectangleShape(0, 0, 10, windowy)
  objects.block3.fixture = love.physics.newFixture(objects.block3.body, objects.block3.shape, 2)
  
  objects.block4 = {}
  objects.block4.body = love.physics.newBody(world, windowx+5, windowy/2, "static")
  objects.block4.shape = love.physics.newRectangleShape(0, 0, 10, windowy)
  objects.block4.fixture = love.physics.newFixture(objects.block4.body, objects.block4.shape, 2)
  
  objects.block5 = {}
  objects.block5.body = love.physics.newBody(world, windowx/2, -5, "static")
  objects.block5.shape = love.physics.newRectangleShape(0, 0, windowx, 10)
  objects.block5.fixture = love.physics.newFixture(objects.block5.body, objects.block5.shape, 2)
  
  love.graphics.setBackgroundColor(104, 136, 100) 
  --love.window.setMode(windowy, windowy) --set the window dimensions to windowy by windowy
end


function love.update(dt)
  world:update(dt)
  x,y=objects.ball.body:getLinearVelocity()
  --------------------------------------------
      if x>100 then
  objects.ball.body:setLinearVelocity(100,y)
  end
    if x<-100 then
  objects.ball.body:setLinearVelocity(-100,y)
  end
    if y>100 then
  objects.ball.body:setLinearVelocity(x,100)
  end
    if y<-100 then
  objects.ball.body:setLinearVelocity(x,-100)
  end
  ---------------------------------------------
  x,y=objects.ball.body:getLinearVelocity()
  if x<10 and x>-10 then
  objects.ball.body:setLinearVelocity(0,y)
  end
  if y<10 and y>-10 then
  objects.ball.body:setLinearVelocity(x,0)
  end
  
  
  x,y=objects.ball.body:getLinearVelocity()
  if love.keyboard.isDown("right") and x<maxspeed then
    objects.ball.body:applyForce(100, 0)
  end
  if love.keyboard.isDown("left") and x>-maxspeed  then 
    objects.ball.body:applyForce(-100, 0)
  end
  if love.keyboard.isDown(" ") then 
    objects.ball.body:setPosition(windowy/2, windowy/2)
  end
  if love.keyboard.isDown("up") and y>-maxspeed then
    objects.ball.body:applyForce(0, -100)
  end
  if love.keyboard.isDown("down") and y<maxspeed  then
    objects.ball.body:applyForce(0, 100)
  end
end

function love.mousepressed(button)
  local ballx, bally = objects.ball.body:getPosition()
  local mx, my = love.mouse.getPosition()
  angle = math.atan2(my - bally, mx - ballx)
  objects.block9 = {}
  objects.block9.body = love.physics.newBody(world, ballx+(math.cos(angle)*12), bally+(math.sin(angle)*12), "dynamic")
  objects.block9.shape = love.physics.newCircleShape(1.5)
  objects.block9.fixture = love.physics.newFixture(objects.block9.body, objects.block9.shape, 2)
  objects.block9.fixture:setRestitution(1)
  table.insert(bullets,objects.block9)
  local shotx, shoty = objects.block9.body:getPosition()
  objects.block9.body:applyLinearImpulse((shotx-ballx)/50,(shoty-bally)/50)
end

function beginContact(a, b, coll)
love.window.setTitle(tostring(a:getUserData()).."   " ..tostring(b:getUserData()).. "  xyz")
  if a==objects.block9 then
	a:destroy()
  end
  if b==objects.block9 then
    b:destroy()
  end
end

function love.draw()
  love.graphics.setColor(255, 255, 255)
  local mx, my = love.mouse.getPosition()
  local bx, by = objects.ball.body:getPosition()
  objects.ball.body:setAngle(math.atan2(my - by, mx - bx))
  love.graphics.circle("fill", objects.ball.body:getX(), objects.ball.body:getY(), objects.ball.shape:getRadius())
  love.graphics.draw(objects.ball.image, objects.ball.body:getX(), objects.ball.body:getY(), objects.ball.body:getAngle(),  1, 1, objects.ball.image:getWidth()/2, objects.ball.image:getHeight()/2)
  
  love.graphics.setColor(50, 0, 50)
  for i,v in ipairs(derp) do
  love.graphics.polygon("fill", v.body:getWorldPoints(v.shape:getPoints()))
  end
  for i,v in ipairs(bullets) do
  love.graphics.circle("fill",v.body:getX(), v.body:getY(), v.shape:getRadius())
  end
  love.graphics.setColor(50, 50, 50)
  for i,v in ipairs(theworld) do  --Draw my world <3
  love.graphics.polygon("fill", v.body:getWorldPoints(v.shape:getPoints()))
  end
end